std::shared_future< _Res >(3cxx)

NAME
std::shared_future< _Res > - Primary template for shared_future.

SYNOPSIS

#include <future>

Inherits std::__basic_future< _Res >.

  Public Types

template<typename _Res> using _Ptr
A unique_ptr for result objects.
using _State_base

  Public Member Functions

shared_future (const shared_future &__sf) noexcept
Copy constructor.
shared_future (future< _Res > &&__uf) noexcept
Construct from a future rvalue.
shared_future (shared_future &&__sf) noexcept
Construct from a shared_future rvalue.
const _Res & get () const
Retrieving the value.
shared_future & operator= (const shared_future &__sf) noexcept
shared_future & operator= (shared_future &&__sf) noexcept
bool valid () const noexcept
void wait () const
template<typename _Rep, typename _Period> future_status wait_for (const chrono::duration< _Rep, _Period > &__rel) const
template<typename _Clock, typename _Duration> future_status wait_until (const chrono::time_point< _Clock, _Duration > &__abs) const

  Static Public Member Functions

template<typename _Res, typename _Allocator> static _Ptr< _Result_alloc< _Res, _Allocator > > _S_allocate_result (const _Allocator &__a)
template<typename _Res, typename _Tp> static _Ptr< _Result< _Res > > _S_allocate_result (const std::allocator< _Tp > &__a)
template<typename _Res_ptr, typename _BoundFn> static _Task_setter< _Res_ptr, _BoundFn > _S_task_setter (_Res_ptr &__ptr, _BoundFn &__call)

  Protected Types

typedef __future_base::_Result< _Res > & __result_type
typedef shared_ptr< _State_base > __state_type

  Protected Member Functions

__result_type _M_get_result () const
Wait for the state to be ready and rethrow any stored exception.
void _M_swap (__basic_future &__that) noexcept

Detailed Description

  template<typename _Res>
class std::shared_future< _Res >"Primary template for shared_future.

Member Typedef Documentation

  template<typename _Res> using std::__future_base::_Ptr [inherited]

A unique_ptr for result objects.

Constructor & Destructor Documentation

  template<typename _Res> std::shared_future< _Res >::shared_future (const shared_future< _Res > & __sf) [inline], [noexcept]

Copy constructor.

  template<typename _Res> std::shared_future< _Res >::shared_future (future< _Res > && __uf) [inline], [noexcept]

Construct from a future rvalue.

References std::move().

  template<typename _Res> std::shared_future< _Res >::shared_future (shared_future< _Res > && __sf) [inline], [noexcept]

Construct from a shared_future rvalue.

References std::move().

Member Function Documentation

  template<typename _Res> __result_type std::__basic_future< _Res >::_M_get_result () const [inline], [protected], [inherited]

Wait for the state to be ready and rethrow any stored exception.

Referenced by std::future< _Res >::get(), std::future< _Res & >::get(), std::future< void >::get(), std::shared_future< _Res >::get(), and std::shared_future< _Res & >::get().

  template<typename _Res> const _Res & std::shared_future< _Res >::get () const [inline]

Retrieving the value.

References std::__basic_future< _Res >::_M_get_result().

Author

Generated automatically by Doxygen for libstdc++ from the source code.